/** Thanks of today go to: https://filippo.io/linux-syscall-table/ */
int main(int argc, char **argv){
  const char *mjono="Hello world.\n";
  const int pituus=13;

  /* Tulostetaan "inline-konekielellä", joka ei ole edes standardia
     C-kieltä... tietenkään, koska yksi C-kielen hienoimmista
     piirteistä, alustariippumattomuus, on täten saatu rikottua täysin
     sullomalla sekaan tietyn laitteen rajapinnan mukaista
     koodia. Normaaliolosuhteissa tällaista ei pitäisi joutua
     tekemään, vaan pitäisi toimia standardikirjastojen päällä!!
     Standardoidun C:n päämäärä on nimenomaan olla matalimman tason
     abstraktiona laitteiston rajapinnan päällä, mutta ei
     alla. POSIXin määräämät kirjastot laajentavat rajapinnan
     kattamaan laitteistojen lisäksi myös yhteensopivat
     käyttöjärjestelmät.

     Esimerkki on kuitenkin hyvä demonstroimaan, kuinka lähellä
     laiterajapintaa C itse asiassa onkaan. Yleisimmät C-kääntäjät
     pystyvät jopa sekoittamaan assembleria saumattomasti, tosin
     syntaksit ovat aina kääntäjien omia laajennoksia, eivät
     standardin mukaisia. Tämä toimii GNU-kääntäjällä. Lisäksi saadaan
     ensihavainto siitä, että käyttöjärjestelmän kutsuminen tapahtuu
     konkreettisesti vielä C:täkin matalammalla tasolla. */

  /* Linux x86_64 syscall for "write": */
  /* (rax==1 ; rdi==file desc. ; rsi==source memory addr. ; rdx==nbytes) */
  asm(
    "movq $1,%%rdi\n;"
    "movq %0,%%rsi\n;"
    "movq %1,%%rdx\n;"
    "movq $1,%%rax\n;"
    "syscall\n"
    :
    : "r"(mjono), "r"((long long int)pituus)
      );
  
  /* Linux x86_64 syscall for exit */
  /* (rax==60 ; rdi==exit code): */
  asm(
    "movq $0,%rdi\n;"
    "movq $60,%rax\n;"
    "syscall\n"
  );
}
