/**
 * Mihin saatettaisiin tarvita säikeitä? Tässä on esimerkki
 * rinnakkaistuvasta tehtävästä, jonka seinäkelloaika saadaan
 * lyhyemmäksi rinnakkaislaskennan avulla.
 *
 * Muita tarpeita? Tausta-ajot, esim. grafiikkaohjelman
 * efektialgoritmit tai nettiselaimen välilehdet tai
 * Download-ominaisuus. Käyttöliittymäsäiettä voisi klikkailla, vaikka
 * ohjelma tekisi samaan aikaan taustatöitä eri paikoissa koodia ja
 * dataa.
 */

#include<stdint.h>
#include<stdio.h>
#include<inttypes.h>
#include<stdlib.h>

#define TAULUN_KOKO 80000000

/**
 * Täyttää taulukon peräkkäisillä, indeksin mukaisilla luvuilla.
 *
 * Jokainen alkio on riippumaton jokaisesta muusta alkiosta.
 * Tällainen tehtävä rinnakkaistuu helposti ja nopeutuu lähestulkoon
 * verrannollisesti rinnakkaisten prosessorien määrään.
 *
 */
void tayta_perakkaisilla(int64_t *t, int64_t a, int64_t b){
    for(int64_t i = a; i<b; i++){
        t[i] = i;
    }
}

int main(int argc, char **argv){
    int64_t *taulukko = malloc(TAULUN_KOKO*sizeof(int64_t));
    tayta_perakkaisilla(taulukko, 0, TAULUN_KOKO);

    // Köyhän miehen testi.. tokko toimi sinne päinkään (pistokoe):
    for(size_t ind=0;ind<TAULUN_KOKO;ind += (TAULUN_KOKO/7+1)){
        printf("taulukko[%d]==%" PRId64 "\n", (int)ind, taulukko[ind]);
    }
    printf("taulukko[%d]==%" PRId64 "\n", TAULUN_KOKO-1, taulukko[TAULUN_KOKO-1]);
    return 0;
}
